%
% This program uses EM to maximise the likelihood of a mixture of local models
% for fitting a regression-like data set.
%
% Questions & Tasks:
% try running from different initial conditions. 
% Are the results the same? Should they be?
% try the model with different numbers of components. Any interesting behaviour?
% Any observations on the behaviour of the likelihood history? 
% 
% In one dimensional problems, can you see the way the prior probabilities
% (probability of component i being the right one given ONLY x)
% indicated by the solid mixture component plots follow the posterior 
% probabilities (probability of component i being the right one given BOTH 
% x & y) indicated by dashed lines?
% For noisy data, do you understand why the dashed lines look noisy when the 
% data is noisy?
%
%
% (Note if you get an error complaining about likelihood decreasing it is my 
% problem - a numerical bug in the code somewhere. Sorry, just run it again!)
%
% How does the model cope with dataset 3 (the 10 dimensional data set used
% in other labs)? Why do you think this is?
% 
% try setting the variable model.learnalg = 2 (which brings in local learning 
% instead of standard EM optimisation. What effect does this have? 
% (The only difference in implementation is in the weighting function for the 
% local optimisation of local model prameters. In EM we seuse the the 
% posterior h(x), and in local learning we use the prior g(x), so the local 
% approach doesn't allow neighbouring models to 'cooperate' to better fit the
% target function.



clear all;
close all;
% Initialise data set
disp(sprintf('\n'))
disp(sprintf('******************************************'))
disp(sprintf('*********MISTURA DE ESPECIALISTA**********'))
disp(sprintf('****************GATED*********************'))
disp(sprintf('*********Com Gradiente Conjugado**********'))
disp(sprintf('\n'))



dataset=input('DIGITE O NUMERO DA PLANTA QUE DESEJA SIMULAR ');

if dataset == 1		% one dimensional data
   trainingdata.inputs = [-1:0.03:1]';
   trainingdata.schedin = trainingdata.inputs;
   N = length(trainingdata.inputs(:,1));
   trainingdata.outputs = sin(10*pi*( trainingdata.inputs(:,1)+ones(N,1)).*sin( trainingdata.inputs(:,1)/2).^3)+ 0.1*randn(N,1); 
    inputstest = [-1:0.05:1]';
elseif dataset == 2	% two dimensional data
   %load trains1   % try also trains2
   load dados2
   [X,Xv,Xt1,Xt2]=norma3(X,Xv,Xt1,Xt2,1);
	%trainingdata.inputs = trains1(:,1:2);
   trainingdata.inputs = X;
   trainingdata.schedin = trainingdata.inputs;
  	%trainingdata.outputs = trains1(:,3);
   trainingdata.outputs = S;
   %inputstest = [-1.57:0.05:1.57]';
   inputstest=Xt1;
   
elseif dataset==3
   %load trains1   % try also trains2
   load dados3
   [X,Xv,Xt]=norma2(X,Xv,Xt,1);
	%trainingdata.inputs = trains1(:,1:2);
   trainingdata.inputs = X;
   trainingdata.schedin = trainingdata.inputs;
  	%trainingdata.outputs = trains1(:,3);
   trainingdata.outputs = S;
   %inputstest = [-1.57:0.05:1.57]';
   inputstest=Xt;
   
elseif dataset==4
   %load trains1   % try also trains2
   load dados4
   [X,Xv,Xt]=norma2(X,Xv,Xt,1);
	%trainingdata.inputs = trains1(:,1:2);
   trainingdata.inputs = X;
   trainingdata.schedin = trainingdata.inputs;
  	%trainingdata.outputs = trains1(:,3);
   trainingdata.outputs = S;
   %inputstest = [-1.57:0.05:1.57]';
   inputstest=Xt;
   
elseif dataset==5
   %load trains1   % try also trains2
   load dados5
   [X,Xv,Xt1,Xt2]=norma2(X,Xv,Xt1,Xt2,1);
	%trainingdata.inputs = trains1(:,1:2);
   trainingdata.inputs = X;
   trainingdata.schedin = trainingdata.inputs;
  	%trainingdata.outputs = trains1(:,3);
   trainingdata.outputs = S;
   %inputstest = [-1.57:0.05:1.57]';
   inputstest=Xt1;

elseif dataset == 6	% ten dimensional data, first 3 of which are nonlinear
			% the next two linear to output, then last 5 no effect
                        % on output
   close all
   % you can experiment with number of inputs used 
   scheduse = [1:10];	% try reducing this to 1:3
   inpuse   = [1:10];	% try reducing this to 1:5
   load train200
   trainingdata.inputs = train200(:,inpuse);
   trainingdata.outputs = train200(:,11);
   trainingdata.schedin = trainingdata.inputs(:,scheduse);

   load test10000
   testdata.inputs = test10000(:,inpuse);
   testdata.schedin = testdata.inputs(:,scheduse);
   testdata.outputs = test10000(:,11);
   inputstest = [0:0.05:1]';
   fprintf('Note that mean error in this example is on test set, not on training data.\n');
end
[N, diminput]     = size(trainingdata.inputs);
[dummy, dimsched] = size(trainingdata.schedin);
[dummy, dimoutput] = size(trainingdata.outputs); 


% set up model
%model.Nm        = 2;	   % Number of components. Feel free to change this!
model.Nm=input('DIGITE O NUMERO DE REDES ESPECIALISTA  ');

model.hp=input('DIGITE O NUMERO DE NEURONIOS NA CAMADA ESCONDIDA DA REDE ESPECIALISTA  ');

model.hg=input('DIGITE O NUMERO DE NEURONIOS NA CAMADA ESCONDIDA DA REDE GATING        ');
%model.learnalg  = 1;  	% 1 - EM, 2 - Local. Feel free to change this.
%model.lmtype    = 1;	% Select mixture of linear models
maxIter         = 500;	% Maximum number of EM iterations allowed
model.dimsched  = dimsched;

model.models    = struct('EQM',cell(model.Nm,1), ...
   						   'A', [model.hp,diminput+1], ...
							   'B', [dimoutput,model.hp+1], ...
								'stddev', ones(1, dimoutput));
%                  		'Sigmatheta', eye(diminput+1,diminput+1));
               
% set the mixture means to randomly chosen data points.
model.gating = struct('EQM', 0, ...
							 'A',[model.hg,diminput+1],...
							 'B',[model.Nm,model.hg+1]);

for m = 1:model.Nm
    %a = randperm(N); % pick Nm reandom points for centres
    %model.gating(m).centre = trainingdata.schedin(a(m),:);
    model.models(m).A = rands(model.hp, diminput+1)/5;
    model.models(m).B = rands(dimoutput,model.hp+1)/5;    
 end
 
 
 model.gating.A=rands(model.hg,diminput+1)/2;
 model.gating.B=rands(model.Nm,model.hg+1)/2;

% start identification of model parameters
Likelihood  = [];
Meanerrlist = [];
h 	    = [];
finished    = 0;
i           = 1;
%inputstest  = [-1.5:0.05:1.5];

%gates = gate(model.gating, trainingdata.schedin);

%model = Mstep(model, trainingdata, gates, gates);
erro_val=valida(model,Xv,Sv);


while i < maxIter & ~finished

   % E- & M-step. These two functions are the core of the identification
   % algorithm
   
   [h, gates, thisLike] = Estep(model, trainingdata);
   model 		= Mstep(model, trainingdata, h, gates);

   Likelihood = [Likelihood; thisLike];

   % rest of loop is purely graphic displays
  % displaymoe;
   drawnow

   if i > 2
      if Likelihood(end) < Likelihood(end-1)
         fprintf('Likelihood decreased! Probably due to numerical problem in code. %f->%f\n',Likelihood(end-1),Likelihood(end))
         finished = 1;
      elseif  Likelihood(end) < Likelihood(end-1) + 0.001
         fprintf('Converged\n')
         finished = 1;
      end
   end
   i = i + 1;
   
   %   plot(gates)
	%   model.models(1).stddev
	 %  model.models(2).stddev
	 % pause(2)
 	nerro_val=valida(model,Xv,Sv);
   if nerro_val<erro_val
      erro_val=nerro_val;
      disp(sprintf('ERRO DE VALIDACAO %d',erro_val))
		if dataset == 1
   		disp('Planta nao congifurada ainda')
		elseif dataset == 2
		   save planta2 model Likelihood
		elseif dataset ==3
		   save planta3 model Likelihood
		elseif dataset ==4
		   save planta4 model Likelihood
		elseif dataset ==5
		   save planta5 model Likelihood
		 end  
    end
end

if dataset == 1
	disp('Planta nao congifurada ainda')
elseif dataset == 2
   save final2 model Likelihood
elseif dataset ==3
   save final3 model Likelihood
elseif dataset ==4
   save final4 model Likelihood
elseif dataset ==5
   save final5 model Likelihood
end  


% Display surface plots of the model & its individual components
if dimsched == 2
fprintf('Plotting response of individual basis functions in 3D\n')
x = [-1.5:0.02:1.5];
[X, Y] = meshgrid(x,x);
gates = plotgates(model, x);

figure(4)
clf
for i = 1:model.Nm
   surf(X,Y,reshape(gates(:,i),length(x), length(x)))
   hold on
end
hold off
shading interp
title('P.d.f. of individual gating functions')
rotate3d on
end
