%**************************************************************
% Este programa realiza o treinamento dos especialistas
% com uma camada intermediaria
% Metodo do gradiente
% Treinamento em batelada
% Data: 22/06/99
% Autor: Clodoaldo Aparecido de Moraes Lima
%****************************************************************

function Esp=treina_esp(X,S,Esp,m)

% Calcula o numero de entradas e saidas
[N,ne]=size(X);
[N,ns]=size(S);

%Define o erro minimo
erromin=1e-4;

% Define o numer de epocas maximo
nepocasmax=10;



for i=1:m,
   
   Sr=Esp(i).S;
   %----------------------------------------
   % Treina o especialista
   %---------------------------------------
   
   A=Esp(i).A;
   B=Esp(i).B;
   Peso=Esp(i).Peso;
   h=Esp(i).h;
	% Define a taxa de aprendizado
	alfa=1;

	% Calcula a saida da rede
	Esp(i).S=perceptrons(X,A,B);

	% Calcula o Erro quadratico medio
	Esp(i).fi=calcfi(Esp(i).S,S,Esp(i).sig,N,ns);

	fobj=-Peso'*log(Esp(i).fi);
   
   fobj_ant=fobj+1;

	nepocas=0;

	while  (fobj_ant-fobj)>erromin & nepocas <nepocasmax
   
   	% Incrementa o numero de epocas
	   nepocas=nepocas+1;
      
     	disp(sprintf('Treinando especialista %d na epoca %d com sig %d com erro %d',i,nepocas,Esp(i).sig,fobj))

   	% Calcula o Gradiente
	   [dJdA,dJdB]=processa(X,A,B,S,Peso,Esp(i).sig,h);
      
   	% Transforma para vetor
	   vetdJdA=reshape(dJdA,1,h*(ne+1))';
   	vetdJdB=reshape(dJdB,1,ns*(h+1))';
   
   	% Monta o vetor gradiente
	   g=[vetdJdA;vetdJdB];
            
      % Normaliza o vetor gradiente
	   g=g/norm(g);
   
   	% Transforma em vetor
	   vetdJdA=g(1:h*(ne+1));
   	vetdJdB=g(h*(ne+1)+1:end);
   
   	% Transforma em matriz
	   dJdA=reshape(vetdJdA',h,ne+1);
   	dJdB=reshape(vetdJdB',ns,h+1);
   
   	% Atualiza a matriz A e B
	   Aatual=A-alfa*dJdA;
   	Batual=B-alfa*dJdB;
   
   	% Calcula a saida da rede
	   Esp(i).S=perceptrons(X,Aatual,Batual);

	   % Calcula o Erro quadratico medio
	   Esp(i).fi=calcfi(Esp(i).S,S,Esp(i).sig,N,ns);
      
      fobjatual=-Peso'*log(Esp(i).fi);
   
	   while fobjatual>fobj
   	   alfa=alfa/2;
      
      	% Atualiza a matriz A e B
	      Aatual=A-alfa*dJdA;
   	   Batual=B-alfa*dJdB;
   
   	   % Calcula a saida da rede
      	Esp(i).S=perceptrons(X,Aatual,Batual);

	   
		   % Calcula o Erro quadratico medio
          Esp(i).fi=calcfi(Esp(i).S,S,Esp(i).sig,N,ns);

		   fobjatual=-Peso'*log(Esp(i).fi);

	   end
   	% Incrementa a taxa de aprendizagem
	   alfa=alfa*2;
   
   	% Atualiza as matrizes de entrada e saida
	   A=Aatual;
      B=Batual;
      fobj_ant=fobj;
      fobj=fobjatual;
      
      if alfa<1e-3
         disp('Passo ficou pequeno')
         disp(alfa)
        % pause
      end
      
      if fobj<0
         disp('Funcao objetiva tornou zero')
%         pause
	   end

   	% Plota o grafico da saida
	   %figure(1)
   	%clf
	    %plot(Peso.*S)
    	%hold on
	  % plot(Peso.*Esp(i).S,'r--')
     % grid
      
      %erro=S-Esp(i).S;
	   %dif=erro.*erro;
   	%Esp(i).sig=sum(Peso.*dif)/sum(Peso);
	 %  Esp(i).sig
   	%Esp(i).fi=calcfi(Esp(i).S,S,Esp(i).sig,N,ns);
   
   
   %	fobj=-Peso'*log(Esp(i).fi)
   
   %	pause

      
	end

   Esp(i).A=A;
   Esp(i).B=B;
   erro=S-Sr;
	dif=erro.*erro;
   Esp(i).sig=sum(Peso.*dif)/sum(Peso);
  	disp(sprintf('Especialista %d com sig %d sum(peso) %d',i,Esp(i).sig,sum(Peso)))

%   if Esp(i).sig<0.2
 %     Esp(i).sig=0.2;
   %   disp('Variancia caiu muito')
   %end
   
   Esp(i).fi=calcfi(Esp(i).S,S,Esp(i).sig,N,ns);
   
   
   %	fobj=-Peso'*log(Esp(i).fi)
   
   %	pause


   
end


   
   
   