%**************************************************************
% Este programa realiza o treinamento dos especialistas
% com uma camada intermediaria
% Metodo do gradiente
% Treinamento em batelada
% Data: 22/06/99
% Autor: Clodoaldo Aparecido de Moraes Lima
%****************************************************************

function Gat=treina_gat(X,S,Gat)

% Calcula o numero de entradas e saidas
[N,ne]=size(X);
[N,ns]=size(S);

%Define o erro minimo
erromin=1e-4;

% Define o numer de epocas maximo
nepocasmax=10;

A=Gat.A;
B=Gat.B;
h=Gat.h;

% Define a taxa de aprendizado
alfa=1;

% Calcula a saida da rede
Gat.S=perceptrons_g(X,A,B);

% Calcula o Erro quadratico medio
verro=-S.*log(Gat.S);
fobj=sum(sum(verro')');
   
fobj_ant=fobj+1;
   
nepocas=0;

while  (fobj_ant-fobj)>erromin & nepocas <nepocasmax
   
  	% Incrementa o numero de epocas
   nepocas=nepocas+1;
   
  	disp(sprintf('Treinando gating na epoca %d com erro %d',nepocas,fobj))

   % Calcula o Gradiente
   [dJdA,dJdB]=processa_g(X,A,B,S,h);
   
  	% Transforma para vetor
   vetdJdA=reshape(dJdA,1,h*(ne+1))';
  	vetdJdB=reshape(dJdB,1,ns*(h+1))';
      
   % Monta o vetor gradiente
   g=[vetdJdA;vetdJdB];
   
   % Normaliza o vetor gradiente
	g=g/norm(g);
   
   % Transforma em vetor
	vetdJdA=g(1:h*(ne+1));
   vetdJdB=g(h*(ne+1)+1:end);
   
   % Transforma em matriz
	dJdA=reshape(vetdJdA',h,ne+1);
   dJdB=reshape(vetdJdB',ns,h+1);
   
   % Atualiza a matriz A e B
	Aatual=A-alfa*dJdA;
   Batual=B-alfa*dJdB;
   
	% Calcula a saida da rede
   Gat.S=perceptrons_g(X,Aatual,Batual);

	% Calcula o Erro quadratico medio
	verro=-S.*log(Gat.S);
	fobjatual=sum(sum(verro')');
      
    		
  while fobjatual>fobj
  	   alfa=alfa/2;
      
     	% Atualiza a matriz A e B
      Aatual=A-alfa*dJdA;
  	   Batual=B-alfa*dJdB;
   
		% Calcula a saida da rede
		Gat.S=perceptrons_g(X,Aatual,Batual);

		% Calcula o Erro quadratico medio
  		verro=-S.*log(Gat.S);
		fobjatual=sum(sum(verro')');

	end
   % Incrementa a taxa de aprendizagem
	alfa=alfa*2;
   
   % Atualiza as matrizes de entrada e saida
	A=Aatual;
   B=Batual;
   
   fobj_ant=fobj;
   fobj=fobjatual;
   
      
   if alfa<1e-3
      disp('Passo ficou pequeno')
      alfa
      %pause
   end
   
   if fobj<0
      disp('Funcao objetiva tornou zero')
     % pause
   end
   
   
   % Plota o grafico da saida
   %figure(1)
  	%clf
   %plot(S,'r--')
  	%hold on
   %plot(Gat.S,'b--')
   %grid
   
end

Gat.A=A;
Gat.B=B;
   


   
   
   