%gate.m                                                                                             
%100664     502     454         1277  6647404524  10362  0                                                                                                    ustar   rod                             users                                                                                                                                                                                                                  
function gates = gate(gating, inputs, normalise)

% returns the probability of each local model being correct for the given inputs

if nargin < 3
   normalise = 1;
end
[N,diminput] = size(inputs);
Nm           = length(gating);
gates 	    = zeros(N,Nm);
P 	 			 = zeros(N,Nm);
dist         = zeros(N,1);
gaussian = 1;

if gaussian
   for m = 1:Nm
      differ = inputs-ones(N,1)*gating(m).centre;
      Sigma = gating(m).Sigma;
      Sigmainv = inv(Sigma);
      for i=1:N
         dist(i) = differ(i,:)*Sigmainv*differ(i,:)';
      end
      P(:,m) = exp(-dist/2)./(eps+sqrt(det(Sigma))*(2*pi)^(diminput/2));  
		gates(:,m)=gating(m).weighting*P(:,m); 
   end %  for m
   
   if normalise
      gates = gates./(sum(gates')'*ones(1,Nm));
   end
end % if gaussian

