%**************************************************************
% Utiliza gradiente conjugado escalonado hibrido
% Hessiana calculado pelo metodo exato
% n = [numero de unidades ocultas , numero de saidas];
% X = entrada (numero de entradas x numero de amostras)
% S = saida desejada (numero de amostras X pelo numero de saidas)
% MISTURA DE ESPECIALISTA - REDE GATING
% Autor: Clodoaldo Aparecido de Moraes Lima
%*************************************************************
function[A,B,EQM]=treinamento(X,S,A,B,h)

% Calcula o numero de entradas e saidas
[N,ne]=size(X);
[N,ns]=size(S);

% Monta o vetor n
n=[h,ns];

%Inicializa o vetor de erros
nerro=[];

%Define o erro minimo
erromin=1e-5;

% Define o numero de epocas maximo
nepocamax=1500;

%Inicializa a epoca inicial
nepocas=0;

% Constantes do algoritmo
lambatual=0;       % pode variar de 0 -- 10e-6
lambant=0;         % lambda barra
sucesso=1;         % 1 - verdaddeiro, 0 - falso

% Inicializa o contador
cont=1;

% Calcula o numero de parmetros
npar=h*(ne+1)+ns*(h+1);

% Calcula o gradiente
[Ew,dEw] = processa_gating(X,S,A,B,n,ne,N);

% Armazena o valor do erro
EQM=Ew
nerro=[nerro,EQM];


pat=-dEw;
rat=-dEw;
rant=-dEw;

while EQM>erromin & nepocas<nepocamax
   	
   if sucesso ==1
      %Calculando a infromao de Segunda Ordem
      vetdJdAv=pat(1:h*(ne+1));
      vetdJdBv=pat(1+h*(ne+1):end);
      Av=reshape(vetdJdAv,ne+1,h)';
      Bv=reshape(vetdJdBv,h+1,ns)';
      s=hprocessa_gating(X,S,A,B,Av,Bv,n,ne,N);
      pHp=pat'*s;
      normapat=pat'*pat;
      delta=pHp;
   end
   
   delta=delta+(lambatual-lambant)*normapat;
   
   if delta <=0
      lambant=lambatual;
      lambatual=2*(lambant-delta/normapat);
      delta=-delta+lambant*normapat;
    end
      
   mi=pat'*rat;
      
   alfa=mi/delta
      
   Aaux=A+alfa*Av;
   Baux=B+alfa*Bv;
   
   [Ewaux,dEwaux] = processa_gating(X,S,Aaux,Baux,n,ne,N);
   
   Ewp=Ew+alfa*pat'*dEw+(1/2)*(alfa*pHp*alfa);
   
   deltacomp=(Ew-Ewaux)/(Ew-Ewp);   %Ewv --> calculado corretamente
      
   if deltacomp >= 0      
      
	   nepocas=nepocas+1
      
      lambant=0;
      
      sucesso=1;
      
      A=Aaux;
      
      B=Baux;
         
      dEw=dEwaux;
      
      Ew=Ewaux;
            
      rant=rat;
      
      rat=-dEw;
      
      EQM=Ew
      nerro=[nerro,EQM];
      
      if cont == npar
         beta=0;
         pat=rat;
         cont=1;
      else      
         betaPR=(rat'*rat-rat'*rant)/(rant'*rant);
         betaFR=rat'*rat/(rant'*rant);
         
         if betaPR>0 & betaPR<betaFR
            pat=rat+betaPR*pat;
            cont=cont+1;
            beta=betaPR;
            
            if (pat'*rat)<0
               beta=0;
               pat=rat;
               cont=1;
               disp('Alfa ser negativo')
            end
            
            %elseif betaPR>betaFR
         elseif betaPR>betaFR
            pat=rat+betaFR*pat;
            cont=cont+1;
            beta=betaFR;
            
            if (pat'*rat)<0
               beta=0;
               pat=rat;
               cont=1;
               disp('Alfa ser negativo')
            end
            
         else
            beta=0;
            pat=rat;
            cont=1;
            disp('Reinicializando')   
         end
                 
      end
      
      if deltacomp >= 0.75
         lambatual=(1/4)*lambatual;
      end
      
   else
      
      sucesso=0;
         
      if deltacomp < 0.25
         lambant=lambatual;
         lambatual=lambant+delta*(1-deltacomp)/normapat;
      end
      
   end
   
   Sr = perceptrons_gating(X,A,B);
   % Plota o grafico da saida
   figure(1)
   clf
   plot(S)
   hold on
   plot(Sr,'r--')
   grid
	drawnow      
end


%figure(2)
%clf
%plot(S,'b')
%grid
%hold on
%plot(Sr,'r--')
%title('Sada Desejada(azul) x Sada da Rede Neural(ver)')
%xlabel('Dados de Treinamento')
%drawnow

%figure(3)
%clf
%plot(0:length(nerro)-1,nerro)
%grid
%title('Erro Quadrtico Mdio (EQM)')
%xlabel('Nmero de pocas')
%ylabel('EQM')
%drawnow
%pause


