% Cancer - cancer diagnosis: 569 samples, 30 features, 2 classes
% University of California Repository of Machine Learning Databases
% Domain Theories avaliable free at:
% ftp.ics.uci.edu/pub/machine-learning-databases
%----------------------------------------------------------------
% Artigo 
% Application of the Evolutionary Algorithms for Classifier
% Selection in Multiple Classifier Systems with Majority Voting
% Autor: Dymitr Ruta and Bogdan Gabrys
% Conjunto de treinamento, validao e teste com mesmo tamanho, 
% mas respeitando a proporo das classes
%----------------------------------------------------------------

function dados_cancer()

nrun= 10; % Numero de simulaes realizadas

for i=1:nrun,
wdbc_cancer;

[N,m]=size(X);
N1=length(find(Y==1));
N2=length(find(Y==-1));

perc1=N1/N;
perc2=N2/N;

%Ntr  - Numero de pontos para treinamento
%Ntr1 - Numero de pontos da classe 1 para treinamento
%Ntr2 - Numero de pontos da classe -1 para treinamento

%Nval - Numero de pontos para validao
%Nval1 - Numero de pontos da classe 1 para validaao
%Nval2 - Numero de pontos da classe -1 para validao

%Nts  - Numero de pontos para teste
%Nts1 - Numero de pontos da classe 1 para teste
%Nts2 - Numero de pontos da classe -1 para teste

Ntr=round(N/3);
Nval=round(N/3);
Nts=N-Ntr-Nval;

Ntr1=round((N1/N)*Ntr);
Ntr2=round((N2/N)*Ntr);

Nval1=round((N1/N)*Nval);
Nval2=round((N2/N)*Nval);

Nts1=N1-Ntr1-Nval1;
Nts2=N2-Ntr2-Nval2;

I=randperm(N); % Mistura os dados randomicamente
I=I'; % Tranforma em vetor

Y=Y(I,:);
X=X(I,:);

I1=find(Y==1);
I2=find(Y==-1);

inicio1=1;
fim1=Ntr1;
inicio2=1;
fim2=Ntr2;
Ytr=[Y(I1(inicio1:fim1),:);Y(I2(inicio2:fim2),:)];
Xtr=[X(I1(inicio1:fim1),:);X(I2(inicio2:fim2),:)];

inicio1=1+fim1;
fim1=fim1+Nval1;
inicio2=1+fim2;
fim2=fim2+Nval2;
Yval=[Y(I1(inicio1:fim1),:);Y(I2(inicio2:fim2),:)];
Xval=[X(I1(inicio1:fim1),:);X(I2(inicio2:fim2),:)];

inicio1=1+fim1;
fim1=fim1+Nts1;
inicio2=1+fim2;
fim2=fim2+Nts2;
Yts=[Y(I1(inicio1:fim1),:);Y(I2(inicio2:fim2),:)];
Xts=[X(I1(inicio1:fim1),:);X(I2(inicio2:fim2),:)];

if i==1
   save dados1_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==2
   save dados2_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==3
   save dados3_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==4
   save dados4_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==5
   save dados5_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==6
   save dados6_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==7
   save dados7_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==8
   save dados8_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==9
   save dados9_cancer569 Xtr Ytr Xts Yts Xval Yval
elseif i==10
   save dados10_cancer569 Xtr Ytr Xts Yts Xval Yval
end

end