% ****************************************************************
% Funo Gabor
% f(x,y)=(1/2*pi)*exp(-x^2+y^2/2*(0.5)^2)*cos(2*pi*(x+y))
% 64 pontos de treinamento uniformemente distribuido no Intervalo [-1.5,1.5]x[-1.5,1.5]
% 192 pontos de validao randomicamente distribuido [-1.5,1.5]x[-1.5,1.5]
% 192 pontos de teste randomicamente distribuido [-1.5,1.5]x[-1.5,1.5]
% 1)Structurally Adaptive Localized Mixtures of Experts for
% Non-Stationary Enviroments
% Autor: Vismanath Rmamurti, Joydeep Ghosh
%
% 2)Structural Adaptatio in Mixture of Experts
% Autor: Vismanath Rmamurti, Joydeep Ghosh
%******************************************************************


function dados_gabor()

nrun= 10; % Numero de simulaes realizadas

Ntr=225;
Nval=192;
Nts=192;
fator=0.5^2;
passo=3/(sqrt(Ntr)-1);

for i=1:nrun,
   [x1,x2] = meshgrid(-1.5:passo:1.5, -1.5:passo:1.5);
   x1=reshape(x1,Ntr,1);
   x2=reshape(x2,Ntr,1);
   Xtr=[x1,x2];   
   Ytr=(1/(2*pi*fator))*exp(-(x1.^2+x2.^2)/(2*fator)).*cos(2*pi*(x1+x2));
   
   Xval=rands(Nval,2);
   x1=Xval(:,1);
   x2=Xval(:,2);
   Yval=(1/(2*pi*fator))*exp(-(x1.^2+x2.^2)/(2*fator)).*cos(2*pi*(x1+x2));

   Xts=rands(Nts,2);
   x1=Xts(:,1);
   x2=Xts(:,2);
   Yts=(1/(2*pi*fator))*exp(-(x1.^2+x2.^2)/(2*fator)).*cos(2*pi*(x1+x2));
   
   if i==1
      save dados1_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==2
      save dados2_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==3
      save dados3_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==4
      save dados4_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==5
      save dados5_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==6
      save dados6_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==7
      save dados7_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==8
      save dados8_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==9
      save dados9_gabor Xtr Ytr Xts Yts Xval Yval
   elseif i==10
      save dados10_gabor Xtr Ytr Xts Yts Xval Yval
   end

end

[N,m]=size(Xtr);

if m==2
   x1=reshape(Xtr(:,1),sqrt(N),sqrt(N));   
   x2=reshape(Xtr(:,2),sqrt(N),sqrt(N));
   Y=reshape(Ytr,sqrt(N),sqrt(N));
   surf(x1,x2,Y)
end


