%**************************************************************
% Predicting Chaotic Dynamic
% Autor: Clodoaldo Ap. Moraes Lima
% Data ultima atualizacao 30/06/2003
% x(t)=0.2x(t-tal)/(1+x(t-tal)^10)-0.1x(t)
% Conjunto de dados 1
%       Numero de pontos de treinamento - 220
%       Numero de pontos de validacao   - 220
%       Numero de ponto de teste        - 58
% Conjunto de dados 2
%       Numero de pontos de treinamento - 220
%       Numero de pontos de validacao   - 29
%       Numero de ponto de teste        - 29
% Entrada = [ x(t-18) x(t-12) x(t-6) x(t)]
% Saida = x(t+6)
% Artigo
% 1) Adaptive-Network-Based Fuzzy Inference System
% Jyh-Shing Roger Jang

% 2)A. S. Lapedes and R. Farber. Nonlinear signal processing using 
% neural networks: prediction and system modeling. Technical Report 
% LA-UR-87-2662, Los Alamos National Laboratory, Los Alamos, New Mexico
% 87545, 1987.
%*********************************************************************


function dados_macglass()

% load raw time series data
load mgdata.dat
time = mgdata(:, 1);
ts = mgdata(:, 2);

% Preprocessing
[N,n]=size(ts);
lb = -1;, ub = 1;
mina = min(ts(101:1124));
maxa = max(ts(101:1124));
sca=maxa-mina;
scamax = max(sca);
ts =(ub-lb)*(ts  -ones(N, 1)*mina)/scamax+lb;


% prepare training data
Xtr = zeros(500, 4);
Ytr = zeros(500, 1);
start = 101;
Xtr(:, 1) = ts(start:start+500-1); 
start = start + 6;
Xtr(:, 2) = ts(start:start+500-1); 
start = start + 6;
Xtr(:, 3) = ts(start:start+500-1); 
start = start + 6;
Xtr(:, 4) = ts(start:start+500-1); 
start = start + 6;

Ytr(:, 1) = ts(start:start+500-1); 

% prepare checking data
X = zeros(500, 4);
Y = zeros(500, 1);
start = 601;
X(:, 1) = ts(start:start+500-1); 
start = start + 6;
X(:, 2) = ts(start:start+500-1); 
start = start + 6;
X(:, 3) = ts(start:start+500-1); 
start = start + 6;
X(:, 4) = ts(start:start+500-1); 
start = start + 6;
Y(:, 1) = ts(start:start+500-1); 

nrun=2;

for i=1:nrun,
    if i==1
        % prepare checking data
        Xval=Xtr;
        Yval=Ytr;
        % prepare test data
        Xts=X;
        Yts=Y;
        save dados1_macglass Xtr Ytr Xts Yts Xval Yval
    elseif i==2
        % prepare checking data
        Nx=length(X);
        Nval=floor(Nx/2);
        Nts=Nx-Nval;
        Xval=X(1:Nval,:);
        Yval=Y(1:Nval,1);
        % prepare test data
        Xts=X(Nval+1:end,:);
        Yts=Y(Nval+1:end,1);
        save dados2_macglass Xtr Ytr Xts Yts Xval Yval
    end
end

