%*********************************************************
% Modeling a Two-Input Nonlinear Function
% z= sinc(x,y)= sin(x)/x*sin(y)/y
% 121 pontos de treinamento uniformemente distribuido no Intervalo [-10,10]x[-10,10]
% 225 pontos de validao randomicamente distribuido [-10,10]x[-10,10]
% 625 pontos de teste randomicamente distribuido [-10,10]x[-10,10]
% Artigo
% 1) Adaptive-Network-Based Fuzzy Inference System
% Jyh-Shing Roger Jang
%
%**********************************************************

function dados_sinc

nrun= 10; % Numero de simulaes realizadas
Ntr=121;
Nval=225;
Nts=625;

for i=1:nrun,
   
   % ====== collect training data
   point_n = 11;
   x = linspace(-10-1e-10, 10, point_n);
   y = linspace(-10-1e-10, 10, point_n);
   [xx, yy] = meshgrid(x, y);
   
   tmp1 = sin(xx)./(xx);
   index = find(isnan(tmp1)==1);
   tmp1(index) = ones(size(index));
   
   tmp2 = sin(yy)./(yy);
   index = find(isnan(tmp2)==1);
   tmp2(index) = ones(size(index));
   
   zz = tmp1.*tmp2;
   trn_data = [xx(:) yy(:) zz(:)];
   
   Ytr=reshape(zz,Ntr,1);
   x1=reshape(xx,Ntr,1);
   x2=reshape(yy,Ntr,1);
   Xtr=[x1,x2];
   
   % ====== collect validation data   
   Nval=225;
   
   Xval=10*rands(Nval,2);
   
   xx=Xval(:,1);
   yy=Xval(:,2);
   
   tmp1 = sin(xx)./(xx);
   index = find(isnan(tmp1)==1);
   tmp1(index) = ones(size(index));
   
   tmp2 = sin(yy)./(yy);
   index = find(isnan(tmp2)==1);
   tmp2(index) = ones(size(index));
   
   Yval = tmp1.*tmp2;
   
   
   % ====== collect training data
   Nts=625;
   
   Xts=10*rands(Nts,2);
   
   xx=Xts(:,1);
   yy=Xts(:,2);   
   
   tmp1 = sin(xx)./(xx);
   index = find(isnan(tmp1)==1);
   tmp1(index) = ones(size(index));
   
   tmp2 = sin(yy)./(yy);
   index = find(isnan(tmp2)==1);
   tmp2(index) = ones(size(index));
   
   Yts = tmp1.*tmp2;
   
     if i==1
      save dados1_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==2
      save dados2_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==3
      save dados3_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==4
      save dados4_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==5
      save dados5_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==6
      save dados6_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==7
      save dados7_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==8
      save dados8_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==9
      save dados9_sinc Xtr Ytr Xts Yts Xval Yval
   elseif i==10
      save dados10_sinc Xtr Ytr Xts Yts Xval Yval
   end

end

[N,m]=size(Xtr);

if m==2
   x1=reshape(Xtr(:,1),sqrt(N),sqrt(N));   
   x2=reshape(Xtr(:,2),sqrt(N),sqrt(N));
   Y=reshape(Ytr,sqrt(N),sqrt(N));
   surf(x1,x2,Y)
end
