% ****************************************************************
% Wang et al
% Tese Fernando Jose Von Zuebn
%******************************************************************


function dados_wang()

nrun= 10; % Numero de simulaes realizadas

Ntr=225;
Nval=225;
Nts=625;
fator=0.5^2;
passo=1/(sqrt(Ntr)-1);

for i=1:nrun,
   [x1,x2] = meshgrid(0:passo:1, 0:passo:1);
   x1=reshape(x1,Ntr,1);
   x2=reshape(x2,Ntr,1);
   Xtr=[x1,x2];   
   Ytr=1.3356*(1.5*(1-x1)+exp(2*x1-1).*sin(3*pi*(x1-0.6).^2)+exp(3*(x2-0.5)).*sin(4*pi*(x2-0.9).^2));
   
   Xval=rand(Nval,2);
   x1=Xval(:,1);
   x2=Xval(:,2);
   Yval= 1.3356*(1.5*(1-x1)+exp(2*x1-1).*sin(3*pi*(x1-0.6).^2)+exp(3*(x2-0.5)).*sin(4*pi*(x2-0.9).^2));

   Xts=rand(Nts,2);
   x1=Xts(:,1);
   x2=Xts(:,2);
   Yts= 1.3356*(1.5*(1-x1)+exp(2*x1-1).*sin(3*pi*(x1-0.6).^2)+exp(3*(x2-0.5)).*sin(4*pi*(x2-0.9).^2));
   
   if i==1
      save dados1_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==2
      save dados2_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==3
      save dados3_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==4
      save dados4_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==5
      save dados5_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==6
      save dados6_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==7
      save dados7_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==8
      save dados8_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==9
      save dados9_wang Xtr Ytr Xts Yts Xval Yval
   elseif i==10
      save dados10_wang Xtr Ytr Xts Yts Xval Yval
   end

end

[N,m]=size(Xtr);

if m==2
   x1=reshape(Xtr(:,1),sqrt(N),sqrt(N));   
   x2=reshape(Xtr(:,2),sqrt(N),sqrt(N));
   Y=reshape(Ytr,sqrt(N),sqrt(N));
   surf(x1,x2,Y)
end


