function x=maglass(N,taul)
% mg.m: Mackey Glass generator  

tt = 6;	               % sampling rate
dt=0.005;					% inegrate step
NN=N*tt/dt;             % final number of samples
tau=taul/dt;			   % Mackey-Glass paramater
x = zeros(NN+1,1); 

% Runge-Kutta Method
xxd=0;
x(1)=1.2; 					% initial conditions

for ts=1:NN,
  xx=x(ts);
   
  if ts>=tau
 		xxd=x(ts-tau+1);    
  end

 xk1 = dt*mg1(xx,xxd);
 xk2 = dt*mg1(xx+xk1/2,xxd);
 xk3 = dt*mg1(xx+xk2/2,xxd);
 xk4 = dt*mg1(xx+xk3,xxd);
 
 x(ts+1) = xx + xk1/6 + xk2/3 +xk3/3 +xk4/6; 
 
end

x = x(1:1/dt:NN);

%x1=x;


%xmin = min(x);      
%xmax = max(x);      
%xdmin = 0.1;      
%xdmax = 0.9;    

%x = (x-xmin)*((xdmax-xdmin)/(xmax-xmin))+xdmin;    

%Xold=zeros(1,4);
%for i=1:NN,
 %  X(i,:)=[x(i,1),
% resample every tt/dt
%y = x(1:tt/dt:NN);



%function [mgx] = mg1(x,xd)
%	mgx = -0.1*x + .2*xd/(1+xd^10);