%	BAsic matlab tutorial for CIS students
%

%***********************************************************
%    1. Matlab basics
%**********************************************************
% Matlab is an interpreting programming language that supports all
% basic operations and functions like other programming languages
% (e.g. if then else structure, for loop, while loop, case-switch structure, 
% break, try, catch, return, ...)

a=10
if (a==4)
   b=a^2
elseif (a~=10)
   b=a
else
   b=-a
end

for i=1:2:10
	i   
end

help case
%pause


% It supports help system through help window, or through help statement from the
% command prompt (e.g. help case)
% There is also a lookfor statement, when we are not sure what is the exact name of 
% the statement or the function. Lookfor searches for specifief word through description 
% of all available MAtlab functions
% e.g. "lookfor write" gives all functions that contains the word write in their
% description

% In addition, Matlab has integrated powerful functons for elementary matrix 
% manipulation and numerical linear algebra, elementary and specialized math 
% functions, 2D and 3D graphic, interpolation, polynomials, Fourier transforms,
% sparse matrices, .....

% Unlike other languages it DOES NOT make executable code. Insteda, it interprets
% comands of functions written in the script or inside the another funstion.


% Function has a specific syntax and should be called.
% It can have more than one input and output arguments.
% Normally, arguments are transfered by value. It is possible to submit arguments 
% by reference (as common attributes for caller and the function), but you'll 
% never need this...

a = 5
b = 4
[sum_ab, product_ab] = operations(a, b)
%pause


%*********************************************************
% 2. Matrix operations
%*********************************************************

A = [1  2  3 
     4  5  6
     7  8  9
     10 11 12]
   
B = [1  3  5
     7  11  13
     17 19  23
     29 31 37]
%pause
   
% Another way to represent matrix   
C = [1 2 3 4; 5 6 7 8; 9 10 11 12]
%pause

D = A + B
%pause

E = A * C
%pause

F = C * B
%pause
F1 = inv(sqrt(F))

A
B
G = B./ A
%pause
G_transpose = G'
G_transpose = transpose(G)


% Matlab is very powerful in matrix computation.
% DO NOT USE for loop for computing with matrices. THERE IS ALWAYS 
% FASTER WAY TO DO SOMETHING
[num_rows, num_cols] = size(A)
%pause

num_rows = size(A,1)
%pause

num_cols = size(A,2)
%pause

A
sum(A)      % sumation performed by first index (sums of columns!)
sum (A,1)   % The same
%pause

sum(A,2)    %sumation performed by the second index (sum of rows)
%pause

sum(sum(A)) %sum all elements in the matrix
%pause

% BASIC STATISTIC
A
mean_A_column = mean(A)        % Mean for columns
mean_A_row    = mean(A,2)      % Mean for rows
std_A_column  = std(A)         % Standard devaition of columns 
std_A_row     = std(A,[],2)    % Standard deviation of rows ([] MUST be here)
%pause

% SEPARATE one COLUMN (Attribute)
A
for i = 1:size(A,2)
  A_column = A(:,i)
end
%pause

% SEPARATE one ROW (Data Example)
A
for  i = 1:size(A,1)
  A_row = A(i,:)
end  
%pause

% Special matrix functions
diagonal_matrix=diag([1 2 3 4])
all_zeros=zeros(3,4)
all_ones=ones(4,2)
identity_matrix=eye(4)
%pause


%*********************************************************
% 3. Input/output
%*********************************************************

% How to save results

% To save specified variables into specified file in ascii form'
E
save ascii_matrix.txt E -ASCII 

%'To save specified variables into specified file in binary (matlab-specific) form'
% Default extension is .mat
save bin_matrices A B C


% To save ALL variables, write only a file name. All variables in scope 
% will be saved
save binary_all

whos A
%pause
clear A
whos 
'there is no variable A now'
%pause
clear all  %delete all variables in scope
whos
'everything is deleted'
%pause

% How to load results

% From binary file
%

load  binary_all
whos
%pause

% From ASCII file.
% This is tricky, but we may use dopen function for reading files that contain only one numerical matrix
% otherwise, we must write our own program using scanf functions

E_matrix = open_ascii('ascii_matrix.txt',4)
E
%pause



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 4. Graphic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
t=0:0.1:5;
x=sin(pi*t)+0.1*t;
y=cos(pi*t)-0.2*t;
plot(x,y);
%pause

hold on
plot(x,y, 'r*');     % plots blue stars instead of line
%pause

figure;
z=2*t;
plot3(x,y,z,'m-d');  % shows magenta diamonds in addition to line


% Other nice graphic functions imagesc, surf, meshgrid, ..... 
% TRY HELP for these commands


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   5. Some useful functions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

a = [0     7     1     5     0
     1     7     4     6     1
     4     3     9     1     5
     8     9     4     5     0
     9     3     3     5     2
     0     1     4     9     3
     7     7     7     9     9
     8    10     7     5     3
     7     2     9     8     3
     10     4     8     7     4]
%pause   

a1 = sort(a)      % SORT each colun separately
%pause
a2 = sort(a,2)    % SORT each row separately

% FIND all rows (examples) where the values in
% second columen are greater than 5
a
q = find(a(:,2) > 5)
%pause
% PRINT these rows
a_found = a(q,:)
%pause

% FASTER WAY TO DO THIS, BUT LESS COMPREHENSIVE
a_foud1 = a(find(a(:,2) > 5),:)
%pause

b = rand(500,5);
hist(b(:,1),20);   % Histogram in 20 bins
%pause


