function [post,lik,lli] = calc_saida_hme(hme,k,x,y)

error(nargchk(3,4,nargin));
if nargin > 3,
    % error(nargoutchk(1,3,nargout));
else
    %error(nargoutchk(1,1,nargout));
end

[d,n] = size(x);

if hme.leaf,
    
    % evaluate expert
    if nargin > 3,
        switch lower (hme.type)
        case 'linear'
            [post,lik,lli] = linearK_eval(hme.param,hme.sig,x,y);
        case 'mlp'
            [post,lik,lli] = mlpK_eval(hme.param,hme.sig,x,y);
        case 'svm'
            disp('nao implementado')
        end
    else
        switch lower(hme.type)
        case 'linear'
            post = linearK_eval(hme.param,hme.sig,x);
        case 'mlp'
            post = mlpK_eval(hme.param,hme.sig,x);
        case 'svm'
            disp('nao implementado')
        end    
    end
    
else
    
    % evaluate gating function
    switch lower(hme.type)
    case 'linear'
        gate = linearKg_eval(hme.param,x);
    case 'mlp'
        gate = mlpKg_eval(hme.param,x);
    case 'Gaussiano'
        disp('Nao implementado')
    end
    
    % combine post,lik from children using gating function
    post = zeros(k,n);
    lik = zeros(1,n);        
    
    global count_plot level;
    
    count_plot=count_plot+1;
    [d,n]=size(gate);            
    figure(count_plot)
    subplot(d,1,1);
    for j=1:d,
        subplot(d,1,j)
        plot(gate(j,:))
        title(level)
    end
    
    for i = 1:length(hme.children),
        
        level=level+1;
        
        if nargin > 3,
            [post_i,lik_i] = calc_saida_hme(hme.children{i},k,x,y);
            lik = lik + lik_i .* gate(i,:);
        else
            post_i = calc_saida_hme(hme.children{i},k,x);
        end

        %figure(count_plot)
        %subplot(d,1,1);
        if hme.children{i}.leaf
%            xx=[xx,post_i'];
        else
            %count_plot=count_plot+1;
        end
        %if
        %if isempty(xx)
            %[d,n]=size(gate);            
            %figure(count_plot)
            %subplot(d,1,1);
            %for j=1:d,
            %    subplot(d,1,j)
                %plot(gate(j,:))
                %pause
                %end
                %end        
        i
        pause
        post = post + post_i .* repmat(gate(i,:),k,1);
    end
    
    % log-likelihood
    if nargin > 3,
        lli = sum(log(lik+eps));
    end
    
end

