 function [h, gates, Likelihood] = Estep(model, D)
% 
% estimates the posterior probability of the missing values
% and returns them in h. 
% gates variable is the unconditional probability of each data point
% belonging to a given model
% Likelihood is loglikelihood of model
%
% (c) Roderick Murray-Smith, Jan 1999, DTU, Denmark

%normalise =  ~(model.lmtype==0);
%gates = gate(model.gating, D.schedin, normalise);
gates = gate(model.gating, D.schedin);

pY = proby(model, D);

h1 = gates.*pY;
%h1 = h1 + eps*ones(size(h1));

h1=h1+(h1==0)*eps;

h  = h1./(sum(h1')'*ones(1,model.Nm));

Likelihood = sum(log(sum(h1')));
%-sum(sum((h*(log(gates')+log(pY')))'))
%L2 = sum(log(sum((h.*pY)'))) 

