%globMstep.m                                                                                         
%100664     502     454        11557  6647404524  11420  0                                                                                                    ustar   rod                             users                                                                                                                                                                                                                 
function model = globMstep(model, D, h, g)

[N, diminput]   = size(D.inputs);
[N, dimschedin] = size(D.schedin);
if model.lmtype == 1
   [localouts, variances] = locmodel(model, D);

end   
paramvar = zeros(N,model.Nm);
gates    = gate(model.gating, D.schedin);

if model.learnalg == 3
   % Global learning
   Phi = kron(ones(1,model.Nm),[ones(N,1) D.inputs]).*...
         kron(gates, ones(1,diminput+1));
   invPhi = pinv(Phi,1e-6);
   w 	= invPhi*D.outputs;
   Stheta = ((invPhi'.*(((D.outputs - Phi*w).^2)*ones(1,model.Nm*(diminput+1))))'*invPhi')./N;
   for m=1:model.Nm
      model.models(m).theta  = w(2*m:2*m+diminput-1)';
      model.models(m).offset = w(2*m-1);
      model.models(m).Sigmatheta = diag(Stheta(2*m:2*m+diminput-1,(2*m:2*m+diminput-1)))';
   end
elseif model.learnalg == 4
   % Tikhonov regularised learning
   % Global learning
   Phi = kron(ones(1,model.Nm),[ones(N,1) D.inputs]).*...
         kron(gates, ones(1,diminput+1));
   [u,s,v] = svd(Phi);
   [w,rho,eta] = tikhonov(u,diag(s),v,D.outputs,model.lambda);
   figure(4)
   l_curve(u,diag(s),D.outputs,'tikh');
   figure(5)
   eta = picard(u,diag(s),D.outputs,1);


   F_tikh = fil_fac(diag(s),model.lambda);
   invTikh = v*diag(F_tikh./diag(s))*u(:,1:length(F_tikh))';
   Stheta = ((invTikh'.*(((D.outputs - Phi*w).^2)*ones(1,model.Nm*(diminput+1))))'*invTikh')./N;
   for m=1:model.Nm
      model.models(m).theta  = w(2*m:2*m+diminput-1)';
      model.models(m).offset = w(2*m-1);
      model.models(m).Sigmatheta = diag(Stheta(2*m:2*m+diminput-1,(2*m:2*m+diminput-1)))';
   end


elseif model.learnalg  < 3
   
 for m=1:model.Nm
   sumh = sum(h(:,m));	% normalisation term ~ sum of relevant points

   if model.lmtype == 1   % linear local models
      % calculate local model parameters

      Phi   	= [ones(N,1) D.inputs];
      if model.learnalg == 2
         % local learning
         Q     	= (g(:,m)./(model.models(m).stddev.^2))*ones(1, diminput+1);
      else
         % EM learning
         Q     	= (h(:,m)./(model.models(m).stddev.^2))*ones(1, diminput+1);
      end
      invdesign = pinv((Phi.*Q)'*Phi);
      w 	= (invdesign*(Phi.*Q)'*D.outputs);
      model.models(m).theta  = w(2:diminput+1)';
      model.models(m).offset = w(1);

      % find error variance
      modelerr = D.outputs - Phi*w;
sum(modelerr.^2)/sumh;

      temp 	= invdesign*(Phi.*Q)';
      model.models(m).Sigmatheta = ((temp'.*((modelerr.^2)*ones(1,diminput+1)))'*temp')./sumh;

      % use the trace of the parameter variance times their Hessian to estimate effective
      % local degrees of freedom
      localDOF = diminput+1; %trace((Phi.*Q)'*Phi*model.models(m).invhessian);
 
      smallnumber = 0.0001; % for numerical reasons

      % take into account the variance of model parameters

    %  for i=1:N
    %     paramvar(i,m) = h(i,m)'.*(Phi(i,:)*(model.models(m).Sigmatheta)*Phi(i,:)');
    % end

      model.models(m).stddev = smallnumber  + sqrt(sum(h(:,m)'*(modelerr.^2 ...
       +  paramvar(:,m)))./sumh); %(sumh - localDOF));
     
   elseif model.lmtype == 0	% mixture model

      model.models(m).weighting = sumh/length(h);

     % model.models(m).switchweight = model.models(m).switchweight + ...
     %     0.001*sum(-log(h1(:,m))*((model.models(m).switchweight./model.sumweights)*model.Pmgrad + model.Pm)); 
     % model.models(m).switchweight = max(model.models(m).switchweight,0);
     % model.models(m).switchweight = min(model.models(m).switchweight,1);


   elseif model.lmtype == 2 	% Gaussian Process
      % learn hyperparameters
   %   for m=1:model.Nm
          meanx = sum(D.inputs.*h(:,m)*ones(1,diminput))./sum(h(:,m));
          meany = sum(D.outputs.*h(:,m))./sum(h(:,m));
          x = D.inputs - ones(N,1)*meanx;
          y = D.outputs - ones(N,1)*meany;
          pos = find(h(:,m)>0.05);

          % randomly find 50 from available inputs
          endpos = length(pos);%min(length(pos),50);
          randpos = randperm(length(pos));

          [mu, sigmasq, L, Sigma, Sigmainv] = gaussinf(x(pos(randpos(1:endpos),:)), ...
               x(pos(randpos(1:endpos),:)), y(pos(randpos(1:endpos))), model.models(m).gp);

         % model.models(m).gp.weighting = (h(pos(randpos(1:endpos)),m)./sigmasq)';%./exp(model.models(m).gp.noise);
         model.models(m).gp.weighting = [];
         
          weightvector = struct2vector(model.models(m).gp);
          %[d,dy,dh] = check('gaussmin',weightvector, x(randpos(1:endpos),:), y(randpos(1:endpos)), length(model.models(m).gp.noise));
          
          [weightvector, Likelihood, iters, numfunc] = ...
             cgmin2(weightvector,'gaussmin', 10, x(randpos(1:endpos),:), y(randpos(1:endpos)), length(model.models(m).gp.noise),(h(pos(randpos(1:endpos)),m))');
          
          model.models(m).gp = vector2struct(weightvector, diminput, length(model.models(m).gp.noise));
          model.models(m).gp.meanx = meanx;
          model.models(m).gp.meany = meany;
      %end % m
   end % if
  end
end
