function [X,Xv,Xt]=norma2(X,Xv,Xt,isotropic)

if (nargin <3 | nargin>4) % check correct number of arguments
    help norma2
else
   if (nargin < 4) 
      isotropic = 1;
   end
end

[N,n]=size(X);
[N1,n]=size(Xv);
[N2,n]=size(Xt);

mina = min(X);
maxa = max(X);
sca=maxa-mina;
lb = -1;, ub = 1;

if (isotropic)
   scamax = max(sca);
   X   =(ub-lb)*(X  -ones(N, 1)*mina)/scamax+lb;
   Xv =(ub-lb)*(Xv-ones(N1,1)*mina)/scamax+lb;
	Xt =(ub-lb)*(Xt-ones(N2,1)*mina)/scamax+lb;

else
   X   = (ub - lb)*( X   - ones(N, 1)*mina)./(ones(N ,1)*sca) + lb;
   Xv = (ub - lb)*( Xv - ones(N1,1)*mina)./(ones(N1,1)*sca) + lb;
   Xt = (ub - lb)*( Xt - ones(N2,1)*mina)./(ones(N2,1)*sca) + lb;
end


