function [X,Xv,Xt1,Xt2]=norma2(X,Xv,Xt1,Xt2,isotropic)

if (nargin <4 | nargin>5) % check correct number of arguments
    help norma2
else
   if (nargin < 5) 
      isotropic = 1;
   end
end

[N,n]=size(X);
[N1,n]=size(Xv);
[N2,n]=size(Xt1);
[N3,n]=size(Xt2);

mina = min(X);
maxa = max(X);
sca=maxa-mina;
lb = -1;, ub = 1;

if (isotropic)
   scamax = max(sca);
   X   =(ub-lb)*(X  -ones(N, 1)*mina)/scamax+lb;
   Xv =(ub-lb)*(Xv-ones(N1,1)*mina)/scamax+lb;
	Xt1 =(ub-lb)*(Xt1-ones(N2,1)*mina)/scamax+lb;
	Xt2 =(ub-lb)*(Xt2-ones(N3,1)*mina)/scamax+lb;

else
   X   = (ub - lb)*( X   - ones(N, 1)*mina)./(ones(N ,1)*sca) + lb;
   Xv = (ub - lb)*( Xv - ones(N1,1)*mina)./(ones(N1,1)*sca) + lb;
   Xt1 = (ub - lb)*( Xt1 - ones(N2,1)*mina)./(ones(N2,1)*sca) + lb;
   Xt2 = (ub - lb)*( Xt2 - ones(N3,1)*mina)./(ones(N2,1)*sca) + lb;

end


