%plotgates.m                                                                                         100664     502     454         2027  6647404524  11436  0                                                                                                    ustar   rod                             users                                                                                                                                                                                                                 
function gates = plotgates(model, x)


normalise =  ~(model.lmtype==0);
if model.dimsched == 1
   gates = gate(model.gating, x, normalise);
   plot(x, gates)

elseif model.dimsched == 2
   [X, Y] = meshgrid(x,x);
   inputs = [X(:) Y(:)];
   gates = gate(model.gating, inputs, normalise);
   for m=1:model.Nm
      contour(X, Y, reshape(gates(:,m),length(x),length(x)), [exp(-1) exp(-3)]./(eps+sqrt(det(model.gating(m).Sigma))*(2*pi)^(model.dimsched/2)))
      plot(model.gating(m).centre(:,1), model.gating(m).centre(:,2), 'o')
      hold on
   end
   hold off
   axis('square')   
elseif model.dimsched == 3
   N = 20;
   [X,Y,Z] = sphere(N-1);
   A = zeros(N.^2,3);
   for m=1:model.Nm
      for i=1:N.^2
         A(i,:) = [X(i) Y(i) Z(i)]*2*chol(model.gating(m).Sigma);
      end
      A = A + ones(size(X(:)))*model.gating(m).centre;
      X1 = reshape(A(:,1),N,N);
      Y1 = reshape(A(:,2),N,N);
      Z1 = reshape(A(:,3),N,N);
      surfl(X1, Y1, Z1);
      %material shiny
      %shading interp
      hold on
   end
   hold off
end
drawnow                                                                                                                                                                                                                                                                  
