%plotmodels.m      
%100664     502     454         3117  6647404524  11617  0  
%ustar   rod                             users       
function modelout = plotmodels(model, inputs, trainingdata)

if model.dimsched == 1


   % draw local models
   hold on
   for m = 1:model.Nm
      minx = model.gating(m).centre - 2*sqrt(model.gating(m).Sigma);
      maxx = model.gating(m).centre + 2*sqrt(model.gating(m).Sigma);

      if model.lmtype == 1
         meanlm = [1 1]*(model.models(m).offset)+model.models(m).theta.*[minx maxx];
         % plot mean of local model between +/-2 std. devs
         plot([minx maxx]', meanlm);
         % plot confidence band of local model (at 1 std. deviation).
        % plot([minx maxx]', 2*[1 1]*(model.models(m).stddev)+meanlm,':');
        % plot([minx maxx]', -2*[1 1]*(model.models(m).stddev)+meanlm,':');
     end
   end

   % plot model response

   dataset.inputs  = inputs;
   dataset.schedin = inputs;
   if model.lmtype ~= 0
      [modelout, g, variance]  = meanLMN(model, dataset,trainingdata);

      plot(inputs, modelout,'r-.', inputs, modelout-2*sqrt(variance), 'c--', inputs, modelout+2*sqrt(variance), 'c--');
   elseif model.lmtype == 0
      gates = gate(model.gating, inputs, 0);
      modelout = zeros(length(gates(:,1)),1);
      for i = 1:model.Nm
         modelout = modelout + gates(:,i).*model.models(i).weighting;
      end
      plot(inputs,modelout);
   end

elseif model.dimsched == 2
   [X, Y] = meshgrid(inputs, inputs);
   dataset.inputs  = [X(:) Y(:)];
   dataset.schedin = dataset.inputs;
   modelout  = meanLMN(model, dataset, trainingdata);
   
   mesh(X,Y,reshape(modelout,length(inputs), length(inputs)));
end
hold off

ax = axis;
ax(1:2) = [min(inputs) max(inputs)];
axis(ax)   

