function [hme] = hmeCreateExpert(d,k,param)
% [hme] = hmeCreateExpert(d,k,param)
%
% Create HME model consisting of a single expert.
% The model parameters are initialized to zero if not provided.
%
% INPUTS
%	d	dimensionality of data
%	k	number of classes
%	[param]	dxk matrix of model coefficients
%
% OUTPUTS
%	hme	HME model
%
% See also hmeCreateMixture, hmeInitRand, hmeInitLR. 

% David Martin <dmartin@eecs.berkeley.edu> 
% Charless Fowlkes <fowlkes@eecs.berkeley.edu>
% May 7, 2002

error(nargchk(2,3,nargin));

hme.leaf = 1;

disp(sprintf('Escolha o modelo do especialista'))
disp(sprintf('[1]    - Especialista lineares'))
disp(sprintf('[2]    - Redes Feedforward'))
disp(sprintf('[3]    - Support Vector Machine'))
type_expert=input('Escolha a opcao desejada  ');

if type_expert==1
    hme.param = zeros(d,k);
    hme.type='linear';
elseif type_expert==2
    h=input('\nDigite o numero de neuronios para cada Rede especialista  ');
    hme.param.A = rands(h,d); % Ja tem bias
    hme.param.B = rands(k,h+1);
    hme.type='mlp';
    hme.h=h;
elseif type_expert==3
    hme.param.alpha=[];
    hme.param.bias=0;
    hme.type='svm';
end

if nargin == 3,
  hme.param = param;
end

