function [hme] = hmeCreateMixture(children,d,param)
% [hme] = hmeCreateMixture(children,b,d,param)
%
% Create HME model consisting of a mixture of a set of HME models.
% The model parameters are initialized to zero if not provided.
%
% INPUTS
% 	children 	1xb cell array of HME models
%	d		dimensionality of data
%	[param]		dxb matrix of mixing model coefficients
%
% OUTPUTS
%	hme		HME model
%
% See also hmeCreateExpert, hmeInitRand, hmeInitLR. 

% David Martin <dmartin@eecs.berkeley.edu> 
% Charless Fowlkes <fowlkes@eecs.berkeley.edu>
% May 7, 2002

error(nargchk(2,3,nargin));

b = length(children);

hme.leaf = 0;

disp(sprintf('Modelos de Rede Gating'))
disp(sprintf('[1] - Gating lineares'))
disp(sprintf('[2] - Redes Feedforward'))
disp(sprintf('[3] - Kernels Normalizados'))
type_gating=input('Escolha a opcao desejada  ');

if type_gating==1
    hme.param = zeros(d,b);
    hme.type='linear';
elseif type_gating==2
    h=input('\nDigite o numero de neuronios para cada Rede especialista  ');
    hme.param.A = rands(h,d);
    hme.param.B = rands(b,h+1);
    hme.type='mlp';
    hme.h=h;
elseif type_gating==3
    hme.param.m=[];
    hme.param.sigma=0;
    hme.type='localized';
end

hme.children = children;

if nargin == 3,
  hme.param = param;
end

