function hmeWrite (hme,fname)
% hmeWrite (hme,fname)
%
% Write a HME model to a file.
%
% INPUTS
%	hme	HME model.
%	fname	File name (string).
%
% OUTPUTS
%	none
%
% See also hme.
%
% David Martin <dmartin@eecs.berkeley.edu>
% May 2002

error(nargchk(2,2,nargin));

[fid,msg] = fopen(fname,'w');
if fid == -1, error(msg); end
hmeWriteTree(hme,fid);
fclose(fid);

function hmeWriteTree(hme,fid)
  fwrite(fid,hme.leaf,'int32');
  fwrite(fid,size(hme.param),'int32');
  fwrite(fid,hme.param,'double');
  if ~hme.leaf,
    fwrite(fid,length(hme.children),'int32');
    for i = 1:length(hme.children),
      hmeWriteTree(hme.children{i},fid);
    end
  end
