% Multi-Class Hierarchical Mixture of Experts Model
%
% Throughout, n = number of samples, d = dimensionality of samples,
% k = number of classes.  In the gating network, b = branching factor.
%
% The HME data structure is a tree.  Internal nodes and leaf nodes
% are of different types.  
%
% The leaf node (expert) fields are:
%
%	hme.leaf	Set to 1
%	hme.param	dxk matrix of logistic model coefficients
%
% The internal node (gating) fields are:
%
%	hme.leaf	Set to 0
%	hme.param	dxb matrix of logistic model coefficients
%	hme.children	b-element cell array of children
%
% See also hmeCreate, hmeFit, hmeEval, hmeVis.
%
% David Martin <dmartin@eecs.berkeley.edu> 
% Charless Fowlkes <fowlkes@eecs.berkeley.edu>
% May 7, 2002


