function [hme] = hmeCreateExpert(d,k,param)
% [hme] = hmeCreateExpert(d,k,param)
%
% Create HME model consisting of a single expert.
% The model parameters are initialized to zero if not provided.
%
% INPUTS
%	d	dimensionality of data
%	k	number of classes
%	[param]	dxk matrix of model coefficients
%
% OUTPUTS
%	hme	HME model
%
% See also hmeCreateMixture, hmeInitRand, hmeInitLR. 

% David Martin <dmartin@eecs.berkeley.edu> 
% Charless Fowlkes <fowlkes@eecs.berkeley.edu>
% May 7, 2002

error(nargchk(2,3,nargin));

hme.leaf = 1;
hme.param = zeros(d,k);

if nargin == 3,
  hme.param = param;
end

