%18/12/2001
%rotina para o calculo do produto H*p
% function s = hprocessa(X,S,w1,w2,v1,v2,n,m,N)

function s = hprocessaem(X,S,w1,w2,v1,v2,n,m,N);
ns = n(2);
x1 = [X ones(N,1)];        % acrescenta entrada para bias
rx1 = zeros(N,m+1);        % Rv(x1) = matriz nula
y1 = tanh(x1*w1');         % saidas da camada oculta
% s1 = x1*w1' --> somas para as unidades ocultas
rs1 = x1*v1'+rx1*w1';      % Rv(s1)
ry1 = rs1.*(1-y1.*y1);     % Rv(y1)
x2 = [y1  ones(N,1)];      % entradas para as unidades de saida
% s2 = y2= x2*w2' --> rs2 = ry2 = rx2*w2'+x2*v2'
% rx2 = [ry1  zeros(N,1)]  % Rv(x2)
rx2 = [ry1 zeros(N,1)];
y2 = x2*w2';
ry2 = x2*v2'+rx2*w2';      % Rv(y2)

erro2 = zeros(N,ns);   % erro2 = dEdy2 deltas para as saidas
rerro2 = zeros(N,ns);
dgdy2 = zeros(ns,ns);
rdgdy2 = zeros(ns,ns);
 
for t = 1:N,    % para cada padrao 
  g = exp(y2(t,:))/sum(exp(y2(t,:)));
  rg = exp(y2(t,:)).*( sum(exp(y2(t,:)))*ry2(t,:) - ...
                      sum(exp(y2(t,:)).*ry2(t,:)) )/(sum(exp(y2(t,:)))^2); 
  for j = 1:ns,    % para cada saida da rede MLP
    for i = 1:ns,      %para cada funcao gi: dgi/dy2j
          if i == j,
             dgdy2(j,i) = 1-g(i);
             rdgdy2(j,i) = -rg(i);
          else
             dgdy2(j,i) = -g(j);
             rdgdy2(j,i) = -rg(j);
          end
    end
    dEdy2(j) = -S(t,:)*dgdy2(j,:)';    % derivadas de E em relacao a y2j
    rdEdy2(j) = -S(t,:)*rdgdy2(j,:)';
  end
  erro2(t,:) = dEdy2;      % deltas para o padrao t
  rerro2(t,:) = rdEdy2; 
end

rw2 = erro2'*rx2+rerro2'*x2;    % Rv(dET/dw2)
erro1 = (erro2*w2(:,1:n(1))).*(1.0-y1.*y1);  
rerro1 = (rerro2*w2(:,1:n(1)) + erro2*v2(:,1:n(1))).*(1.0-y1.*y1)+...
         (erro2*w2(:,1:n(1))).*(-2*y1.*(1.0-y1.*y1)).*rs1;
rw1 = erro1'*rx1+rerro1'*x1;
rEw = [reshape(rw1',n(1)*(m+1),1);reshape(rw2',n(2)*(n(1)+1),1)];
s = rEw;
%rEw=Rv(dEw) = Rv{[dET/dw1(1,1) dET/dw1(1,2)...dET/dw1(1,0) dET/dw1(2,1) dET/dw1(2,2)...dET/dw1(2,0)
%      ...dET/dw1(h,1) dET/dw1(h,2)...dET/dw1(h,0) dET/dw2(1,1) dET/dw2(1,2)...dET/dw2(1,0)
%      ...dET/dw2(2,1) dET/dw2(2,2)...dET/dw2(2,0)  ....
%      ...dET/dw2(C,1) dET/dw2(C,2)...dET/dw2(C,0)]'}