%18/12/2001
%rotina para o calculo do gradiente
%function [Ew,dEw] = processaem(X,S,w1,w2,n,m,N)

function [Ew,dEw] = processaem(X,S,w1,w2,n,m,N);

ns = n(2);
x1 = [X  ones(N,1)];      % acrescenta bias as entradas
y1 = tanh(x1*w1');        % somas para as unidades ocultas
x2 = [y1  ones(N,1)];     % entradas para as unidades de saida
y2 = x2*w2';              % saidas da rede com ativacoes lineares
Ew = 0;
dgdy2 = zeros(ns,ns);
erro2 = zeros(N,ns);   % erro2 = dEdy2 deltas para as saidas
for t = 1:N,    % para cada padrao 
  g = exp(y2(t,:))/sum(exp(y2(t,:)));
  for j = 1:ns,    % para cada saida da rede MLP
    for i = 1:ns,      %para cada funcao gi: dgi/dy2j
          if i == j,
             dgdy2(j,i) = 1-g(i);
          else
             dgdy2(j,i) = -g(j);
          end
    end
    dEdy2(j) = -S(t,:)*dgdy2(j,:)';    % derivadas de E em relacao a y2j
  end
  erro2(t,:) = dEdy2;      % deltas para o padrao t
  Ew = Ew - sum(S(t,:).*log(g));  
end
dw2 = erro2'*x2;          % dET/dW2
erro1 = (erro2*w2(:,1:n(1))).*(1.0-y1.*y1);
dw1 = erro1'*x1;          % dET/dW1
dEw = [reshape(dw1',n(1)*(m+1),1);reshape(dw2',n(2)*(n(1)+1),1)]; % vetor gradiente  
% dEw = [dET/dw1(1,1) dET/dw1(1,2)...dET/dw1(1,0) dET/dw1(2,1) dET/dw1(2,2)...dET/dw1(2,0)
%      ...dET/dw1(h,1) dET/dw1(h,2)...dET/dw1(h,0) dET/dw2(1,1) dET/dw2(1,2)...dET/dw2(1,0)
%      ...dET/dw2(2,1) dET/dw2(2,2)...dET/dw2(2,0)  ....
%      ...dET/dw2(C,1) dET/dw2(C,2)...dET/dw2(C,0)]'