%**************************************************************
% Utiliza gradiente conjugado escalonado hibrido
% Hessiana calculado pelo metodo exato
% n = [numero de unidades ocultas , numero de saidas];
% X = entrada 
% S = saida desejada
% MISTURA DE ESPECIALISTA - TREINAMENTO REDE ESPECIALISTA
%*************************************************************
function [A,B]=treina_expert(x,y,A,B,w,sig,h)


% Calcula o numero de entradas e saidas
[N,ne]=size(x');
[N,ns]=size(y');

% Monta o vetor n
n=[h,ns];

%Inicializa o vetor de erros
nerro=[];

%Define o erro minimo
erromin=1e-3;

% Define o numero de epocas maximo
nepocamax=20;

%Inicializa a epoca inicial
nepocas=0;

% Constantes do algoritmo
lambatual=0;       % pode variar de 0 -- 10e-6
lambant=0;         % lambda barra
sucesso=1;         % 1 - verdaddeiro, 0 - falso
var=sig^2;
alfa=1;

% Inicializa o contador
cont=1;

% Calcula o numero de parmetros
npar=h*(ne+1)+ns*(h+1);

% Calcula o gradiente
%[Ew,dEw] = processa_expert(X,S,A,B,P,sig,n,ne,N);
dEw = processa_expert(x',y',A,B,w'/var,n,ne,N);

post = computePost(A,B,x);

Ew=-computeLogLik(post,y,w,sig);

% Armazena o valor do erro
%EQM=2*Ew/N
EQM=Ew;

nerro=[nerro,EQM];

pat=-dEw;
rat=-dEw;
rant=-dEw;


%while EQM>erromin & nepocas<nepocamax
while  nepocas<nepocamax
   	
    %disp(sprintf('  Conjugado iter=%d lli=%g stepsize=%g norm (g) = %g',nepocas,-Ew,alfa,norm(dEw)));

   if sucesso ==1
      %Calculando a infromao de Segunda Ordem
      vetdJdAv=pat(1:h*(ne+1));
      vetdJdBv=pat(1+h*(ne+1):end);
      Av=reshape(vetdJdAv,ne+1,h)';
      Bv=reshape(vetdJdBv,h+1,ns)';
      s=hprocessa_expert(x',y',A,B,Av,Bv,w'/var,n,ne,N);
      pHp=pat'*s;
      normapat=pat'*pat;
      delta=pHp;
      
   end
   
   delta=delta+(lambatual-lambant)*normapat;
   
   if delta <=0
      lambant=lambatual;
      lambatual=2*(lambant-delta/normapat);
      delta=-delta+lambant*normapat;
    end
      
   mi=pat'*rat;
      
   alfa=mi/delta;
      
   Aaux=A+alfa*Av;
   Baux=B+alfa*Bv;
      
   %[Ewaux,dEwaux] = processa_expert(X,S,Aaux,Baux,P,n,ne,N);
   dEwaux = processa_expert(x',y',Aaux,Baux,w'/var,n,ne,N);
   
   post2 = computePost(Aaux,Baux,x);

   Ewaux=-computeLogLik(post2,y,w,sig);

   Ewp=Ew+alfa*pat'*dEw+(1/2)*(alfa*pHp*alfa);
   
   deltacomp=(Ew-Ewaux)/(Ew-Ewp);   %Ewv --> calculado corretamente
   
      
   if deltacomp >= 0      
      
       disp(sprintf('  Conjugado iter=%d lli=%g stepsize=%g norm (g) = %g',nepocas,-Ew,alfa,norm(dEw)));

	   nepocas=nepocas+1;
      
      lambant=0;
      
      sucesso=1;
      
      A=Aaux;
      
      B=Baux;        
      
      post=post2;
      
      dEw=dEwaux;
      
      Ew=Ewaux;
            
      rant=rat;
      
      rat=-dEw;
      
      %EQM=2*Ew/N
      EQM=Ew;
      
      nerro=[nerro,EQM];
      
      if cont == npar
         beta=0;
         pat=rat;
         cont=1;
      else      
         betaPR=(rat'*rat-rat'*rant)/(rant'*rant);
         betaFR=rat'*rat/(rant'*rant);
         
         if betaPR>0 & betaPR<betaFR
            pat=rat+betaPR*pat;
            cont=cont+1;
            beta=betaPR;
            
            if (pat'*rat)<0
               beta=0;
               pat=rat;
               cont=1;
               disp('Alfa ser negativo')
            end
            
            %elseif betaPR>betaFR
         elseif betaPR>betaFR
            pat=rat+betaFR*pat;
            cont=cont+1;
            beta=betaFR;
            
            if (pat'*rat)<0
               beta=0;
               pat=rat;
               cont=1;
               disp('Alfa ser negativo')
            end
            
         else
            beta=0;
            pat=rat;
            cont=1;
            disp('Reinicializando')   
         end
                 
      end
      
      if deltacomp >= 0.75
         lambatual=(1/4)*lambatual;
      end
      
   else
      
      sucesso=0;
         
      if deltacomp < 0.25
         lambant=lambatual;
         lambatual=lambant+delta*(1-deltacomp)/normapat;
      end
      
   end
   
   yr = perceptrons_expert(x',A,B);
   % Plota o grafico da saida
   figure(1)
   clf
   plot(y','r--')
   hold on
   plot(yr,'b')
   grid
      
end

% Salva as matrizes A B
%if h == 5
%  save matfinal5 A B;   
%   save nerro5 nerro;
%elseif h==10
%   save matfinal10 A B;      
%   save nerro10 nerro;
%elseif h==15
%   save matfinal15 A B;      
%   save nerro15 nerro;
%elseif h==20
%   save matfinal20 A B;   
%   save nerro20 nerro;
%end

%figure(2)
%clf
%plot(S,'r--')
%grid
%hold on
%plot(Sr,'b')
%title('Sada Desejada(ver) x Sada da Rede Neural(azul)')
%xlabel('DADOS DE TREINAMENTO')

%figure(3)
%clf
%plot(0:length(nerro)-1,nerro)
%grid
%title('Erro Quadrtico Mdio (EQM)')
%xlabel('Nmero de pocas')
%ylabel('EQM')

function lli = computeLogLik(post,y,w,sig)
[k,n] = size(post);

lli = 0;

%for j = 1:k,
%  lli = lli + sum(w.*y(j,:).*log(post(j,:)+eps));
%end
var=sig^2; %variancia  

denom=(2*pi*var)^(k/2);  

diff=(y - post);  

lik=exp(-0.5*(sum(diff.*diff,1))./var)./denom;

lli=sum(w.*log(lik+eps));

if isnan(lli), 
    error('lli is nan'); 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% class posteriors

function post = computePost(A,B,x)

[d,n] = size(x);
%  [d,k] = size(beta);
k=size(B,1);  
post = zeros(k,n);
bx = zeros(k,n);
%  for j = 1:k, 
%    bx(j,:) = beta(:,j)'*x; 
%  end
bx=perceptrons(x',A,B);

bx=bx'; % Realiza transposicao

post=bx;
%for j = 1:k, 
%  post(j,:) = 1 ./ sum(exp(bx - repmat(bx(j,:),k,1)),1);
%end


