function [beta,sig,post,lli] = treina_expert(x,y,xv,yv,xt,yt,w,h,beta,sig)

A=beta.A;
B=beta.B;

[N,ne]=size(x');
[N,ns]=size(y');

goal = 0;
time = inf;
nepocamax=20;
mu=0.001;
mu_max=1e10;
mu_dec=0.1;
mu_inc=10;
 
% Constants
this = 'TRAINLM';
doValidation = ~isempty(xv); %Verifica se precisa realizar validacao
doTest = ~isempty(xt);       % Verifica se precisa realizar teste

% Initialize
flag_stop=0; % Flag de parada
stop = '';   
startTime = clock; % Tempo

npar=h*(ne+1)+ns*(h+1);

ii = sparse(1:npar,1:npar,ones(1,npar)); % Cria uma matriz identidade sparsa

post = computePost(A,B,x);

perf= computeLogLik(post,y,w,sig);

AB=[reshape(A',(ne+1)*h,1);reshape(B',ns*(h+1),1)];

   

AB

if (doValidation)

    vpost = computePost(A,B,xv);
    
    vperf= computeLogLik(vpost,yv,w,sig);

end


for iter=0:nepocamax,
    
    % Calcula a derivada 
    % Jacobian
    %[je,jj,normgX]=calcjejj(net,Pd,Zb,Zi,Zl,N,Ac,El,Q,TS,mem_reduc);
    [jj,je]=processa(x',y',w',A,B,h);
    
    
    
    % Levenberg Marquardt

    while (mu <= mu_max)
        dJdT = -(jj+ii*mu) \ je;
        
        AB2=AB+dJdT;
        
        vetA=AB2(1:(ne+1)*h,1);
        
        vetB=AB2((ne+1)*h+1:end,1);
        
        A2=reshape(vetA',h,ne+1)';
        
        B2=reshape(vetB',h+1,ns)';
        
        post2 = computePost(A2,B2,x);
        
        perf2= computeLogLik(post2,y,w,sig);

        if (perf2 < perf)
            A=A2;
            B=B2;
            post=post2;
            perf=perf2;
            mu = mu * mu_dec;            
            break
            if (mu < 1e-20)
                mu = 1e-20;
            end
        end
        mu = mu * mu_inc;
        mu
        perf2
        perf
        pause
    end
    
    
end



function lli = computeLogLik(post,y,w,sig)
[k,n] = size(post);

lli = 0;

y
post
%for j = 1:k,
%  lli = lli + sum(w.*y(j,:).*log(post(j,:)+eps));
%end
var=sig^2; %variancia  

denom=(2*pi*var)^(k/2);  

diff=(y - post);  

lik=exp(-0.5*(sum(diff.*diff,1))./var)./denom;

lli=sum(w.*log(lik+eps));

if isnan(lli), 
    error('lli is nan'); 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% class posteriors

function post = computePost(A,B,x)

[d,n] = size(x);
%  [d,k] = size(beta);
k=size(B,1);  
post = zeros(k,n);
bx = zeros(k,n);
%  for j = 1:k, 
%    bx(j,:) = beta(:,j)'*x; 
%  end
bx=perceptrons(x',A,B);

bx=bx'; % Realiza transposicao

post=bx;
%for j = 1:k, 
%  post(j,:) = 1 ./ sum(exp(bx - repmat(bx(j,:),k,1)),1);
%end