function [beta,sig,post,lli] = (x,y,xv,yv,xt,yt,w,h,beta,sig)

A=beta.A;
B=beta.B;

[N,ne]=size(x');
[N,ns]=size(y');

goal = 0;
time = inf;
nepocamax=20;
 
% Constants
this = 'TRAINLM';
doValidation = ~isempty(xv); %Verifica se precisa realizar validacao
doTest = ~isempty(xt);       % Verifica se precisa realizar teste

% Initialize
flag_stop=0; % Flag de parada
stop = '';   
startTime = clock; % Tempo

npar=h*(ne+1)+ns*(h+1);

ii = sparse(1:npar,1:npar,ones(1,npar)); % Cria uma matriz identidade sparsa

post = computePost(A,B,x);

perf= computeLogLik(post,y,w,sig);

if (doValidation)

    vpost = computePost(A,B,xv);
    
    vperf= computeLogLik(vpost,yv,w,sig);

end


for i=0:nepocamax,
    
  % Calcula a derivada 
  % Jacobian
  [je,jj,normgX]=calcjejj(net,Pd,Zb,Zi,Zl,N,Ac,El,Q,TS,mem_reduc);
  
  % Training Record
  epochPlus1 = epoch+1;
  tr.perf(epoch+1) = perf;
  tr.mu(epoch+1) = mu;
  if (doValidation)
    tr.vperf(epochPlus1) = VV.perf;
  end
  if (doTest)
    tr.tperf(epochPlus1) = calcperf(net,X,TV.Pd,TV.Tl,TV.Ai,TV.Q,TV.TS);
  end
  
  % Stopping Criteria
  currentTime = etime(clock,startTime);
  if (perf <= goal)
    stop = 'Performance goal met.';
  elseif (epoch == epochs)
    stop = 'Maximum epoch reached, performance goal was not met.';
  elseif (currentTime > time)
    stop = 'Maximum time elapsed, performance goal was not met.';
  elseif (normgX < min_grad)
    stop = 'Minimum gradient reached, performance goal was not met.';
  elseif (mu > mu_max)
    stop = 'Maximum MU reached, performance goal was not met.';
  elseif (doValidation) & (VV.numFail > max_fail)
    stop = 'Validation stop.';
  elseif flag_stop
    stop = 'User stop.';
  end
  
  % Progress
  if isfinite(show) & (~rem(epoch,show) | length(stop))
    fprintf(this);
	if isfinite(epochs) fprintf(', Epoch %g/%g',epoch, epochs); end
	if isfinite(time) fprintf(', Time %4.1f%%',currentTime/time*100); end
	if isfinite(goal) fprintf(', %s %g/%g',upper(net.performFcn),perf,goal); end
	if isfinite(min_grad) fprintf(', Gradient %g/%g',normgX,min_grad); end
	fprintf('\n')
	flag_stop=plotperf(tr,goal,this,epoch);
    if length(stop) fprintf('%s, %s\n\n',this,stop); end
  end
 
  % Stop when criteria indicate its time
  if length(stop)
    if (doValidation)
	  net = VV.net;
	end
    break
  end
  
  % Levenberg Marquardt
  while (mu <= mu_max)
    dX = -(jj+ii*mu) \ je;
    X2 = X + dX;
    net2 = setx(net,X2);
    [perf2,El2,Ac2,N2,Zb2,Zi2,Zl2] = calcperf(net2,X2,Pd,Tl,Ai,Q,TS);

    if (perf2 < perf)
      X = X2; net = net2; Zb = Zb2; Zi = Zi2; Zl = Zl2;
      N = N2; Ac = Ac2; El = El2; perf = perf2;
      mu = mu * mu_dec;
      break
      if (mu < 1e-20)
        mu = 1e-20;
      end
    end
    mu = mu * mu_inc;
  end

  % Validation
  if (doValidation)
    vperf = calcperf(net,X,VV.Pd,VV.Tl,VV.Ai,VV.Q,VV.TS);
	if (vperf < VV.perf)
	  VV.perf = vperf; VV.net = net; VV.numFail = 0;
	elseif (vperf > VV.perf)
      VV.numFail = VV.numFail + 1;
	end
  end
end



function lli = computeLogLik(post,y,w,sig)
[k,n] = size(post);

lli = 0;

%for j = 1:k,
%  lli = lli + sum(w.*y(j,:).*log(post(j,:)+eps));
%end
var=sig^2; %variancia  

denom=(2*pi*var)^(k/2);  

diff=(y - post);  

lik=exp(-0.5*(sum(diff.*diff,1))./var)./denom;

lli=sum(w.*log(lik+eps));

if isnan(lli), 
    error('lli is nan'); 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% class posteriors

function post = computePost(A,B,x)

[d,n] = size(x);
%  [d,k] = size(beta);
k=size(B,1);  
post = zeros(k,n);
bx = zeros(k,n);
%  for j = 1:k, 
%    bx(j,:) = beta(:,j)'*x; 
%  end
bx=perceptrons(x',A,B);

bx=bx'; % Realiza transposicao

post=bx;
%for j = 1:k, 
%  post(j,:) = 1 ./ sum(exp(bx - repmat(bx(j,:),k,1)),1);
%end